// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "EnableInStatusBar.h"
#include <afxpriv.h>        // for WM_SETMESSAGESTRING and AfxLoadString

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP

	// Override the setting of the text in the message pane of the status bar
	ON_MESSAGE(WM_SETMESSAGESTRING, OnSetMessageString)

END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


// Returns the offset of the given menu item's ID or -1 if not found
int GetMenuPosition( CMenu* in_menu, DWORD in_menuItemID )
{
   if ( NULL == in_menu )
      return -1;

   UINT  max = in_menu->GetMenuItemCount();
   for ( UINT i = 0; i < max; i++ )
      if ( in_menuItemID == in_menu->GetMenuItemID( i ) )
         return i;

   return -1;
}

// This method overrides the CFrameWnd's handler for the set message pane for the
// status bar.  This code was taken from CFrameWnd's method and modified.
// Code was added to determine if the control is enabled or not and if disabled
// then indicate how to enable the control or menu item.
LRESULT CMainFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
{
	UINT nIDLast = m_nIDLastMessage;
	m_nFlags &= ~WF_NOPOPMSG;

	// Determine if the menu item that matches the wParam is enabled.  If not,
	// then indicate how to enable it.
	//
	// Load the main frame's menu.  Note we can't use GetMenu because the menu may
	// not have been loaded yet and we need to indicate how to enable the toolbar
	// buttons as well.
	CMenu mainMenu;
	if ( 0 != wParam && mainMenu.LoadMenu( IDR_MAINFRAME ) )
	{
		// Go through each submenu of the main frame looking for the ID passed in.
		UINT  max = mainMenu.GetMenuItemCount();
		for ( UINT i = 0; i < max; i++ )
		{
			CMenu*   pMenu = mainMenu.GetSubMenu( i );
			if ( NULL != pMenu )
			{
				// We need to build a CCmdUI to be used when determining if the item is enabled.
				CCmdUI   state;
				state.m_pMenu = pMenu;
				state.m_nIndexMax = pMenu->GetMenuItemCount();
				state.m_nIndex = GetMenuPosition( pMenu, wParam );

				// If the ID passed in is found in the submenu, then have this frame window
				// enable/disable it.
				if ( -1 != state.m_nIndex )
				{
					// First disable the menu item in case it is not handled.
					pMenu->EnableMenuItem( wParam, MF_GRAYED );
            
					// Invoke the UPDATE COMMAND UI handler for this menu item.
					this->OnCmdMsg(wParam, CN_UPDATE_COMMAND_UI, &state, NULL);

					// Get the state of the menu item.
					UINT  menuState = pMenu->GetMenuState( wParam, MF_BYCOMMAND );

					// If the menu item is disable or grayed out, then get the text to
					// indicate how to enable it.
					if ( ( 0xFFFFFFFF != menuState ) &&
						 ( ( MF_DISABLED & menuState ) ||
						   ( MF_GRAYED & menuState ) ) )
					{
						TCHAR szFullText[256];
						CString strEnableText;
						CWnd* pMessageBar = GetMessageBar();

						// Load the string for this ID.  The string after the second '\n'
						// indicates how to enable.
						AfxLoadString(wParam, szFullText);
						AfxExtractSubString(strEnableText, szFullText, 2, '\n');

						// If there is enable text, then set the message bar to it, otherwise
						// let the parent class handle it.
						if ( 0 != strEnableText.GetLength() )
						{
							pMessageBar->SetWindowText( strEnableText );

							m_nIDLastMessage = (UINT)wParam;    // new ID (or 0)
							m_nIDTracking = (UINT)wParam;       // so F1 on toolbar buttons work
							return nIDLast;
						}
					}
				}
			}
		}
	}

	return CFrameWnd::OnSetMessageString( wParam, lParam );
}
